﻿// <auto-generated />
using System;
using ESDP.Data.Context;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace ESDP.Data.Migrations
{
    [DbContext(typeof(ApplicationDbContext))]
    partial class ApplicationDbContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "2.2.6-servicing-10079")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("ESDP.Data.Entities.AcademicClass", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("AcademicYearId");

                    b.Property<int>("IdentifierClassId");

                    b.Property<bool>("IsDeleted");

                    b.HasKey("Id");

                    b.HasIndex("AcademicYearId");

                    b.ToTable("Classes");
                });

            modelBuilder.Entity("ESDP.Data.Entities.AcademicClassessReportPeriods", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("AcademicClassId");

                    b.Property<bool>("IsDeleted");

                    b.Property<int?>("ReportPeriodId");

                    b.HasKey("Id");

                    b.HasIndex("AcademicClassId");

                    b.HasIndex("ReportPeriodId");

                    b.ToTable("AcademicClassessReportPeriods");
                });

            modelBuilder.Entity("ESDP.Data.Entities.AcademicSubject", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<bool>("IsDeleted");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("NVARCHAR(50)")
                        .HasMaxLength(50);

                    b.HasKey("Id");

                    b.ToTable("AcademicSubjects");
                });

            modelBuilder.Entity("ESDP.Data.Entities.AcademicSubjectsPeriods", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("AcademicSubjectsId");

                    b.Property<bool>("IsDeleted");

                    b.Property<int?>("ReportPeriodId");

                    b.HasKey("Id");

                    b.HasIndex("AcademicSubjectsId");

                    b.HasIndex("ReportPeriodId");

                    b.ToTable("AcademicSubjectsPeriods");
                });

            modelBuilder.Entity("ESDP.Data.Entities.AcademicYear", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<DateTime?>("BeginDate");

                    b.Property<DateTime?>("EndDate");

                    b.Property<bool>("IsCurrent");

                    b.Property<bool>("IsDeleted");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("NVARCHAR(100)")
                        .HasMaxLength(100);

                    b.HasKey("Id");

                    b.ToTable("AcademicYears");
                });

            modelBuilder.Entity("ESDP.Data.Entities.AcademicYearsReportPeriods", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("AcademicYearId");

                    b.Property<bool>("IsDeleted");

                    b.Property<int?>("ReportPeriodId");

                    b.HasKey("Id");

                    b.HasIndex("AcademicYearId");

                    b.HasIndex("ReportPeriodId");

                    b.ToTable("AcademicYearsReportPeriods");
                });

            modelBuilder.Entity("ESDP.Data.Entities.Grades", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("AcademicClassId");

                    b.Property<int?>("AcademicSubjectsId");

                    b.Property<int>("FiveCount");

                    b.Property<int>("FourCount");

                    b.Property<bool>("IsDeleted");

                    b.Property<int>("OneCount");

                    b.Property<int>("ThreeCount");

                    b.Property<int>("TwoCount");

                    b.HasKey("Id");

                    b.HasIndex("AcademicClassId");

                    b.HasIndex("AcademicSubjectsId");

                    b.ToTable("Grades");
                });

            modelBuilder.Entity("ESDP.Data.Entities.IdentifierClass", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("AcademicClassId");

                    b.Property<bool>("IsDeleted");

                    b.Property<string>("Letter")
                        .IsRequired()
                        .HasConversion(new ValueConverter<string, string>(v => default(string), v => default(string), new ConverterMappingHints(size: 1)));

                    b.Property<int>("Parallel");

                    b.HasKey("Id");

                    b.HasIndex("AcademicClassId")
                        .IsUnique()
                        .HasFilter("[AcademicClassId] IS NOT NULL");

                    b.ToTable("IdentifierClasses");
                });

            modelBuilder.Entity("ESDP.Data.Entities.ReportPeriod", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<bool>("IsDeleted");

                    b.Property<string>("Name");

                    b.HasKey("Id");

                    b.ToTable("ReportPeriods");
                });

            modelBuilder.Entity("ESDP.Data.Entities.TeachersAcademicSubjects", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int?>("AcademicSubjectsId")
                        .IsRequired();

                    b.Property<bool>("IsDeleted");

                    b.Property<string>("UserId")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("AcademicSubjectsId");

                    b.HasIndex("UserId");

                    b.ToTable("TeachersAcademicSubjects");
                });

            modelBuilder.Entity("ESDP.Data.Entities.User", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<int>("AccessFailedCount");

                    b.Property<string>("ConcurrencyStamp")
                        .IsConcurrencyToken();

                    b.Property<string>("Email")
                        .HasMaxLength(256);

                    b.Property<bool>("EmailConfirmed");

                    b.Property<bool>("IsBlocked");

                    b.Property<bool>("IsDeleted");

                    b.Property<bool>("LockoutEnabled");

                    b.Property<DateTimeOffset?>("LockoutEnd");

                    b.Property<string>("MiddleName");

                    b.Property<string>("Name")
                        .IsRequired();

                    b.Property<string>("NormalizedEmail")
                        .HasMaxLength(256);

                    b.Property<string>("NormalizedUserName")
                        .HasMaxLength(256);

                    b.Property<string>("PasswordHash");

                    b.Property<string>("PhoneNumber");

                    b.Property<bool>("PhoneNumberConfirmed");

                    b.Property<string>("SecurityStamp");

                    b.Property<string>("Surname")
                        .IsRequired();

                    b.Property<bool>("TwoFactorEnabled");

                    b.Property<string>("UserName")
                        .HasMaxLength(256);

                    b.HasKey("Id");

                    b.HasIndex("NormalizedEmail")
                        .HasName("EmailIndex");

                    b.HasIndex("NormalizedUserName")
                        .IsUnique()
                        .HasName("UserNameIndex")
                        .HasFilter("[NormalizedUserName] IS NOT NULL");

                    b.ToTable("AspNetUsers");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityRole", b =>
                {
                    b.Property<string>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("ConcurrencyStamp")
                        .IsConcurrencyToken();

                    b.Property<string>("Name")
                        .HasMaxLength(256);

                    b.Property<string>("NormalizedName")
                        .HasMaxLength(256);

                    b.HasKey("Id");

                    b.HasIndex("NormalizedName")
                        .IsUnique()
                        .HasName("RoleNameIndex")
                        .HasFilter("[NormalizedName] IS NOT NULL");

                    b.ToTable("AspNetRoles");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityRoleClaim<string>", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("ClaimType");

                    b.Property<string>("ClaimValue");

                    b.Property<string>("RoleId")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("RoleId");

                    b.ToTable("AspNetRoleClaims");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserClaim<string>", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("ClaimType");

                    b.Property<string>("ClaimValue");

                    b.Property<string>("UserId")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("UserId");

                    b.ToTable("AspNetUserClaims");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserLogin<string>", b =>
                {
                    b.Property<string>("LoginProvider");

                    b.Property<string>("ProviderKey");

                    b.Property<string>("ProviderDisplayName");

                    b.Property<string>("UserId")
                        .IsRequired();

                    b.HasKey("LoginProvider", "ProviderKey");

                    b.HasIndex("UserId");

                    b.ToTable("AspNetUserLogins");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserRole<string>", b =>
                {
                    b.Property<string>("UserId");

                    b.Property<string>("RoleId");

                    b.HasKey("UserId", "RoleId");

                    b.HasIndex("RoleId");

                    b.ToTable("AspNetUserRoles");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserToken<string>", b =>
                {
                    b.Property<string>("UserId");

                    b.Property<string>("LoginProvider");

                    b.Property<string>("Name");

                    b.Property<string>("Value");

                    b.HasKey("UserId", "LoginProvider", "Name");

                    b.ToTable("AspNetUserTokens");
                });

            modelBuilder.Entity("ESDP.Data.Entities.AcademicClass", b =>
                {
                    b.HasOne("ESDP.Data.Entities.AcademicYear", "Year")
                        .WithMany("Classes")
                        .HasForeignKey("AcademicYearId")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("ESDP.Data.Entities.AcademicClassessReportPeriods", b =>
                {
                    b.HasOne("ESDP.Data.Entities.AcademicClass", "Class")
                        .WithMany("ReportPeriods")
                        .HasForeignKey("AcademicClassId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("ESDP.Data.Entities.ReportPeriod", "ReportPeriod")
                        .WithMany("Classess")
                        .HasForeignKey("ReportPeriodId")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("ESDP.Data.Entities.AcademicSubjectsPeriods", b =>
                {
                    b.HasOne("ESDP.Data.Entities.AcademicSubject", "Subject")
                        .WithMany("Periods")
                        .HasForeignKey("AcademicSubjectsId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("ESDP.Data.Entities.ReportPeriod", "Period")
                        .WithMany("Subjects")
                        .HasForeignKey("ReportPeriodId")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("ESDP.Data.Entities.AcademicYearsReportPeriods", b =>
                {
                    b.HasOne("ESDP.Data.Entities.AcademicYear", "Year")
                        .WithMany("Periods")
                        .HasForeignKey("AcademicYearId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("ESDP.Data.Entities.ReportPeriod", "Period")
                        .WithMany("Years")
                        .HasForeignKey("ReportPeriodId")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("ESDP.Data.Entities.Grades", b =>
                {
                    b.HasOne("ESDP.Data.Entities.AcademicClass", "Class")
                        .WithMany("Grades")
                        .HasForeignKey("AcademicClassId")
                        .OnDelete(DeleteBehavior.Restrict);

                    b.HasOne("ESDP.Data.Entities.AcademicSubject", "AcademicSubjects")
                        .WithMany("Grades")
                        .HasForeignKey("AcademicSubjectsId")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("ESDP.Data.Entities.IdentifierClass", b =>
                {
                    b.HasOne("ESDP.Data.Entities.AcademicClass", "Class")
                        .WithOne("Identifier")
                        .HasForeignKey("ESDP.Data.Entities.IdentifierClass", "AcademicClassId")
                        .OnDelete(DeleteBehavior.Restrict);
                });

            modelBuilder.Entity("ESDP.Data.Entities.TeachersAcademicSubjects", b =>
                {
                    b.HasOne("ESDP.Data.Entities.AcademicSubject", "Subjects")
                        .WithMany("Teachers")
                        .HasForeignKey("AcademicSubjectsId");

                    b.HasOne("ESDP.Data.Entities.User", "User")
                        .WithMany("Subjects")
                        .HasForeignKey("UserId");
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityRoleClaim<string>", b =>
                {
                    b.HasOne("Microsoft.AspNetCore.Identity.IdentityRole")
                        .WithMany()
                        .HasForeignKey("RoleId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserClaim<string>", b =>
                {
                    b.HasOne("ESDP.Data.Entities.User")
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserLogin<string>", b =>
                {
                    b.HasOne("ESDP.Data.Entities.User")
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserRole<string>", b =>
                {
                    b.HasOne("Microsoft.AspNetCore.Identity.IdentityRole")
                        .WithMany()
                        .HasForeignKey("RoleId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("ESDP.Data.Entities.User")
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("Microsoft.AspNetCore.Identity.IdentityUserToken<string>", b =>
                {
                    b.HasOne("ESDP.Data.Entities.User")
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade);
                });
#pragma warning restore 612, 618
        }
    }
}
